package org.w3c.rdfpic.ui;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
/**
 * This is a special purpose class to provide functionality for the Subject field of
 * the DC schema.
 */
public class DCSubjectCboxMaker implements CboxMaker {
    public JComboBox newCbox(String predName){
	return new DCSubjectCbox();
    }
    public void newFileLoaded(){}//not interested in this.
}

class DCSubjectCbox extends JComboBox {
    static String[] opnames= {"Portrait","Group-Portrait","Landscape","Baby","Architecture","Wedding","Macro","Graphic","Panorama","Animal"};
    MyJCheckBox[] options;
    DCSubjectCbox() {
	super();
	options = new MyJCheckBox[opnames.length];
	for(int i=0;i<opnames.length;i++) {
	    options[i]=new MyJCheckBox();
	    options[i].setText(opnames[i]);
	}
	addItem("(Toggle Options)");
	for(int indx=0;indx<10;indx++) addItem(options[indx]);
	setSelectedIndex(0);
	setRenderer(new DCSubjectCheckBoxRenderer());
	addActionListener(new ActionListener () {
		public void actionPerformed(ActionEvent e) {
		    DCSubjectCbox cb = (DCSubjectCbox)e.getSource();
		    int index=cb.getSelectedIndex()-1;
		    if(index<0) return;
		    options[index].setSelected(!options[index].isSelected());
		    cb.setSelectedIndex(0);
		}
	    });
    }
    public Object getSelectedItem() {
	StringBuffer retval= new StringBuffer();
	for(int i=0;i<opnames.length;i++)
	    if(options[i].isSelected())  retval.append(", "+opnames[i]);
	if(retval.length()==0) return null;
	else return retval.substring(2);
    }
    public void setSelectedItem(Object item) {
	if (item==null) {
	    for(int i=0;i<opnames.length;i++)
		options[i].setSelected(false);
	    return;
	}
	if(item instanceof MyJCheckBox || "(Toggle Options)".equals(item)) {
	    super.setSelectedItem(item);
	} else {
	    String content=item.toString();//item should be a string anyhow...
	    for(int i=0;i<opnames.length;i++)
		options[i].setSelected(content.indexOf(opnames[i])!= -1);
	}
    }
}

class MyJCheckBox extends JCheckBox {}



/**
 * This is a special renderer for the ComboBox of the DC:Subject field so that it can contain
 * Checkboxes.
 */

class DCSubjectCheckBoxRenderer implements ListCellRenderer { //ADDON for special "subject" functionality.
    public Component getListCellRendererComponent(
						  JList list,
						  Object value,
						  int index,
						  boolean isSelected,
						  boolean cellHasFocus)
    {
	if(value==null || value instanceof String) return new JLabel((String)value);
	JCheckBox cb=(JCheckBox)value;
	//	System.out.println("A"+cb.getText());
        if (isSelected) {
	    cb.setBackground(list.getSelectionBackground());
	    cb.setForeground(list.getSelectionForeground());
	} else {
	    cb.setBackground(list.getBackground());
	    cb.setForeground(list.getForeground());
	}
	return cb;
    }
}

